Src/Presentation/3-UI/AdminPanel/Areas/Workspace/Controllers/TasksController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using AutoMapper;
using TaskoMask.Presentation.Framework.Web.Controllers;
using System.Threading.Tasks;
using TaskoMask.Presentation.Framework.Web.Filters;
using TaskoMask.Application.Workspace.Tasks.Services;

namespace TaskoMask.Presentation.UI.AdminPanle.Areas.Workspace.Controllers
{
    [Authorize]
    [Area("Workspace")]
    public class TasksController : BaseMvcController
    {
        #region Fields

        private readonly ITaskService _taskService;


        #endregion

        #region Ctor

        public TasksController(ITaskService taskService, IMapper mapper) : base(mapper)
        {
            _taskService = taskService;
        }

        #endregion

        #region Public Methods



        /// <summary>
        /// 
        /// </summary>
        [HttpGet]
        public async Task<IActionResult> Index()
        {
            var taskQueryResult = await _taskService.SearchAsync(page: 1, recordsPerPage: recordsPerPage, term: "");

            #region ViewBags

            ViewBag.PageSize = taskQueryResult.Value.PageNumber;
            ViewBag.CurrentPage = 1;
            ViewBag.TotalItemCount = taskQueryResult.Value.TotalCount;

            #endregion

            return View(taskQueryResult);
        }



        /// <summary>
        /// 
        /// </summary>
        [HttpGet]
        [AjaxOnly]
        public async Task<IActionResult> Search(int page = 1, string term = "")
        {
            var taskQueryResult = await _taskService.SearchAsync(page: page, recordsPerPage: recordsPerPage, term: term);

            if (!taskQueryResult.IsSuccess)
                return RedirectToErrorPage(taskQueryResult);

            #region ViewBags

            ViewBag.PageSize = taskQueryResult.Value.PageNumber;
            ViewBag.CurrentPage = page;
            ViewBag.TotalItemCount = taskQueryResult.Value.TotalCount;

            #endregion

            return PartialView("_ItemList", taskQueryResult.Value.Items);
        }



        /// <summary>
        /// 
        /// </summary>
        [HttpGet]
        public async Task<IActionResult> Details(string id)
        {
            var taskQueryResult = await _taskService.GetDetailsAsync(id);

            return View(taskQueryResult);

        }





        #endregion

        #region Private Methods



        #endregion

    }
}

Src/Presentation/3-UI/AdminPanel/Areas/Workspace/Views/Tasks/Details.cshtml
@model TaskoMask.Application.Share.ViewModels.TaskDetailsViewModel

@{
    ViewBag.Title = "Task Details";
}

<div class="grid-100 tablet-grid-100 mobile-grid-100">
    <div class="block">
        <div class="block-content no-pad">
            <ul class="tabs">
                <li class="tab"><a href="#tab-1" class="active">Basic Info</a></li>
            </ul>
        </div>

        <div id="tab-1">
            <div class="block-content">
                @await Html.PartialAsync("_BasicInfo", Model.Task)
            </div>
        </div>
    </div>
</div>




@section scripts{

}

Src/Presentation/3-UI/AdminPanel/Areas/Workspace/Views/Tasks/Index.cshtml
@model TaskoMask.Application.Share.Helpers.PaginatedListReturnType<TaskoMask.Application.Share.Dtos.Workspace.Tasks.TaskOutputDto>
@{
    ViewBag.Title = "Tasks List";
}

<div class="grid-content">
    <div class="block">
        <div class="block-bar">
            <form class="form" asp-action="search" data-ajax="true" data-ajax-loading="#global-ajax-loading" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajax-show-list">
                <input name="term" id="term" type="text" value="" placeholder="..." />
                <input type="submit" class="btn btn-primary" value="Search" />
            </form>
        </div>
        <div id="ajax-show-list">
            @await Html.PartialAsync("_ItemList", Model.Items)
        </div>
    </div>
</div>


@section scripts{

}

Src/Presentation/3-UI/AdminPanel/Areas/Workspace/Views/Tasks/_BasicInfo.cshtml
@model TaskoMask.Application.Share.Dtos.Workspace.Tasks.TaskBasicInfoDto
@{
}

<div class="form">

    <fieldset>

        @Html.LabelFor(model => model.Title)
        @Html.TextBoxFor(model => model.Title, new { @class = "form-input-1", @readOnly = "readonly" })


        @Html.LabelFor(model => model.Description)
        @Html.TextBoxFor(model => model.Description, new { @class = "form-input-1", @readOnly = "readonly" })


        @Html.LabelFor(model => model.CreationTime.CreateDateTimeString)
        @Html.TextBoxFor(model => model.CreationTime.CreateDateTimeString, new { @class = "form-input-1", @readOnly = "readonly" })

        <hr />

        <a href="@Url.Action("Index", "Tasks", new { })" class="btn btn-default">
            Back
        </a>

    </fieldset>
</div>

Src/Presentation/3-UI/AdminPanel/Areas/Workspace/Views/Tasks/_ItemList.cshtml
@model IEnumerable<TaskoMask.Application.Share.Dtos.Workspace.Tasks.TaskOutputDto>

@if (Model.Count() == 0)
{
    <div id="no-item-alert-area" class="grid-container">
        <div class="alert alert-info">
            <h4>No item to show!</h4>
        </div>
    </div>
}
else
{
    <div class="block-content has-table">
        <div class="table-responsive">
            <table class="table table-striped table-hover">
                <thead>
                    <tr>
                        <th>@Html.LabelFor(model => model.FirstOrDefault().Title)</th>
                        <th>@Html.LabelFor(model => model.FirstOrDefault().CreationTime.CreateDateTimeString)</th>
                        <th>@Html.LabelFor(model => model.FirstOrDefault().CardName)</th>
                        <th><label></label></th>
                    </tr>
                </thead>
                <tbody>
                    @foreach (var item in Model)
                    {

                        <tr data-table-row-id="@item.Id">
                            <td>
                                @item.Title
                            </td>
                            <td>
                                @item.CreationTime.CreateDateTimeString
                            </td>
                    
                            <td>
                                <a href="@Url.Action( "Details","cards", new { id = item.CardId }) ">
                                    @item.CardName
                                </a>
                            </td>
                            <td>
                                <div class="btn-group-xs">
                                    <a href="@Url.Action( "Details", new { id = item.Id }) " class=" btn btn-primary btn-xs btn-xs-circle">
                                        <i class="fa fa-eye"></i>
                                    </a>
                                </div>
                            </td>
                        </tr>
                    }

                </tbody>
            </table>
        </div>
    </div>
    @await Html.PartialAsync("_PagedList")
}

Src/Presentation/3-UI/AdminPanel/Areas/Workspace/Views/Tasks/_PagedList.cshtml
@using MvcPagedList.Core

@PagedList.Pager(actionName: "search", controllerName: "Tasks", areaName: "Workspace",
    routeValues: new
    {

        term = Context.Request.Query["term"],

    },
    ajaxAttributes: new
    {
        data_ajax = "true",
        data_ajax_loading = "#global-ajax-loading",
        data_ajax_update = "#ajax-show-list",
        data_ajax_method = "GET",
        data_ajax_mode = "replace"


    },
    pagerOptions: new PagerOptions
    {
        currentPage = (int)ViewBag.CurrentPage,
        PageCount = (int)ViewBag.PageSize,
        TotalItemCount = (int)ViewBag.TotalItemCount,
        DisplayMode = PagedListDisplayMode.IfNeeded,
        DisplayInfoArea = true,
        LinkToNextPageFormat = "previous",
        LinkToPreviousPageFormat = "next",
        CurrentLocationFormat = "page",
        PageCountFormat = "from",
        TotalItemCountFormat = "total",
    })